/***************************************************************************
 *   Copyright (C) 2007-2016 by Helge Kortendieck  alan@kasmithee.de       *
 *   abouthelp.cpp  -  show about or help dialog                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/
#include "abouthelp.h"

aboutHelp::aboutHelp(QDialog* parent)
	: QDialog(parent)
{
	uih.setupUi(&wHelp);
	connect(uih.pB_Close, SIGNAL(clicked()), this, SLOT(dlgClose()));
}

aboutHelp::~aboutHelp()
{
}

void aboutHelp::dlgShow(int iD)				// show dialog: 1=about, 2=Help, 3=no system tray
{
//cout << "dlgShow reached : " << endl;
	iDlg = iD;
	if (wHelp.isVisible() == true) {
		wHelp.hide();
	}
	textSet();
	if (iDlg == 1) {
		uih.tb_Help->setHtml(sHelp);
		wHelp.setWindowTitle(tr("about normalizetogo"));
		wHelp.resize(720, 360);
	} else if(iDlg == 2) {
		uih.tb_Help->setHtml(sHelp);
		wHelp.setWindowTitle(tr("normalizetogo - help"));
		wHelp.showFullScreen();
	}
	if ( iDlg == 1 ) {							// 1=about
		qPos = QCursor::pos();
		iD = qPos.x() - 450;
		if(iD < 0) {
			iD = 0;
		}
		iD2 = qPos.y() - 175;
		if(iD2 < 0) {
			iD2 = 0;
		}
		wHelp.move(iD, iD2);
	}
	wHelp.show();
}

void aboutHelp::dlgClose()
{
	wHelp.hide();
	emit sigDelAhw();
}

void aboutHelp::textSet()
{
	if (iDlg == 1) {
		sHelp = tr("<html><body>"
			"normalizetogo - Qt5 based lossy audio normalizator.<p>"
            "normalizetogo re-encodes the original music files to wave,<br>" 
			"normalizes the audio level and then re-encodes to 224 kbit/s mp3_s.<p>" 
			"Using lame for decoding to wave and re-encoding to mp3 and<br>"
			"wavegain to normalize the wav files in between.<p>"
            "Warning, this process is lossy and degrades audio quality!<p>"
            "Version 0.9.1 , Copyright 2015-2016 by Helge Kortendieck<p>"
            "This program is released under GPL2 (or later).<br>"
            "</body></html>");
	} else if (iDlg == 2) {
		sHelp = tr("<html><body>"
			"<a name=""Top""><b>Table of content</b></a><br>"
			"<a href=""#Intro"">Introduction</a><br>"
			"<a href=""#Usage"">Usage</a><br>"
			"<a href=""#Options"">Options</a><br>"
			"<a href=""#Credits"">Credits</a><p>"

			"<hr>"
			"<a name=""Intro""><b><u>Introduction</u></b></a><p>"
			"normalizetogo is a lossy audio normalizator based on Qt5.<br>"
			"It uses lame to decode to wave, wavegain to normalize the wav files and lame again to re-encode the normalized waves to mp3 224 kbit/s.<p>"
            "Warning, this process is lossy and degrades audio quality!<p>"
			"Hence 'togo', suitable rather for copies to mobile devices, car stereos than for a HiFi quality collection.<p>"
			"Currently only mp3_s are supported as input and output files.<p>"
			"Thanks to taglib, some basic audio tags can be re-added to the normalized mp3_s.<p>"
			"normalizetogo works per directory, so a directory with the input files to process must already exist.<br>"
			"Sub-directories whithin this source directory are not supported.<p>"
			"<a href=""#Top"">back to top</a><p>"

            "<hr>"
            "<a name=""Usage""><b><u>Usage</u></b></a><p>"
			"- Create a directory and copy all files you want in the new compilation into it. No sub-directories will be processed.<br>"
            "- Use the file system widget to find the directory with the files to normalize.<br>"
            "- Define the wav directory and select whether any already existing wave files from the current selection should be re-created.<br>"
            "- Define the output directory and file options (See the chapter <a href=""#Options"">Options</a>).<br>"
            "- Click the 'Normalize selection' button.<p>"
            "<a href=""#Top"">back to top</a><p>"

			"<hr>"
			"<a name=""Options""><b><u>Options</u></b></a><p>"
			"<b>2. Select wav dir</b><p>"
				"<b>Create 'wav' subdir within source dir</b><br>"
					"Create the sub-directory in the source directory rather than the directory specified in the line edit.<br>"
				"<b>Delete dir (and files) at end</b><br>"
					"Delete the wave files and the directory they where create in at the end after creating the normalized files. This might not be wanted, if a compilation is going to be re-used. In that case some time can be saved, if the already decoded files are preserved. Use the 'Do not re-create waves, if they already exist' option to benefit from this setting.<p>"
				"<b>Do not re-create waves, if they already exist</b><br>"
					"Skip creating wav files if they already exist. This can save some time if a standard compilation is re-used/enhanced. The previous option 'Delete dir (and files) at end' and the option 'Delete wav files at end' must be un-set to have this option be effective.<p>"
				"<b>Delete wav files at end</b><br>"
					"Delete wav files after successful creating normalized output files. The directory, can be the one in the line edit, will not be deleted.<p>"
			"<b>3. Define output</b><p>"
				"<b>Create 'mp3' subdir within source dir</b><br>"
					"Create the sub-directory in the source directory rather than the directory specified in the line edit.<p>"
				"<b>Randomize output by prefixing with 00-</b><br>"
					"If checked, the filenames will get a random, unique number prefix. Thus a random play order of the input files will be generated.<p>"
				"<b>Eliminate spaces in output file names</b><br>"
					"As said, eliminates any spaces in the output file names. However, spaces should not be an issue these days.<p>"
				"<b>Shorten output name to 8 characters length</b><br>"
					"Shorten the output file name to 8 characters plus '.typ', where typ is either m4a or mp3. This should not be required these days.<p>"
				"<b>Try re-adding tag info from source files</b><br>"
					"If checked, taglib will be used to re-add some main info tags from the source files to the new output files. The tags which are tried are currently tbd.<p>"
			"<a href=""#Top"">back to top</a><p>"

			"<hr>"
			"<a name=""Credits""><b><u>Credits</u></b></a><p>"
			"normalizetogo is based on Qt5.<p>"
			"It uses lame for decoding to wave and re-encoding to mp3 and wavegain to normalize the wav files.<p>"
			"The program icon is made by me, Helge Kortendieck, a combination of 2 svg icons made with inkscape:<br>"
				"faders.svg, from openclipart.org: Faders from mixing board by Upacesky, created 2014-09-05, still available 2016 04 02.<br>"
				"1339873253.svg, from openclipart.org: Note icon by diamonjohn, created 2012-06-16, fetched 2016 04 02.<br>"
				"License of openclipart.org should be 'Public Domain' and therefore the program icon is this as well.<p>"
			"Program icons are taken from the following sources:<br>"
			" - open icon library, version 10 Nov. 2009:<br>"
			" --- theme gnome, licence GPLv2:<br>"
			" ------ about.svg from actions/help-about.svg<br>"
			" ------ help.svg from actions/help-browser.svg<br>"
			" ------ idle.svg from status/task-past-due.svg<br>"
			" ------ refresh.svg from actions/view-refresh-3.svg<br>"
			" ------ save.svg from actions/document-save-2.svg<br>"
			" ------ task-due.svg from status/task-due.svg<br>"
			" --- theme gnome-Colors, licence GPLv2:<br>"
			" ------ exit.svg from actions/application-exit-3.svg<br>"
			" --- theme oxygen, licence CC-BY-SA 3.0 or LGPL:<br>"
			" ------ disabled.svg from actions/dialog-cancel-5.svg<br>"
			" ------ nok.svg from actions/edit-delete-6.svg<br>"
			" ------ ok.svg from actions/dialog-ok-apply-5.svg<br>"
			" ------ settings.svg from categories/preferences-system-4.svg<br>"
			" ------ stop.svg from actions/process-stop-7.svg<br>"
			" --- theme tango, licence PD:<br>"
			" ------ open.svg from actions/document-open-5.svg<br>"
			" - openclipart.org, licence Public Domain:<br>"
			" ------ run.svg from faders.svg, by Upacesky, created 2014-09-05<p>"

				  " create.svg - Tango arch 20101028, actions/go-next.svg<p>"

			"Program and Documentation Copyright 2015-2016 Helge Kortendieck, alan@kasmithee.de .<p>"
			"normalizetogo is released under GPL2 or later.<p>"
			"<a href=""#Top"">back to top</a><p>"
			"</body></html>");
	}
}


#include "abouthelp.moc"
