/****************************************************************************
 *  Copyright (C) 2009-2016 Helge Kortendieck  <alan@kasmithee.de>			*
 *																			*
 *  rw - read/write files:													*
 *		- check for installed programms:	lame, wavegain, taglib			*
 * 		- create and delete directories:	wav, mp3, m4a					*
 *		- 
 * 																			*
 *  This program is free software; you can redistribute it and/or modify	*
 *  it under the terms of the GNU General Public License as published by	*
 *  the Free Software Foundation; either version 2 of the License, or		*
 *  (at your option) any later version.										*
 ***************************************************************************/

#include "rw.h"

	bool b;

	int iProgs;							// installed programs: 0/1=lame, 0x/1x=wavegain, 0xx/1xx=taglib, 0xxx/1xxx=m4a = ??
	int iRwD;

	QString sD;							// dummy
	QString sD2;						// dummy

	QStringList slD;					// dummy


//  ***************************************
//  **  check for installed programs
//  ***************************************
int rwChkProgs()							// check for installed programs
{
	iProgs = 0;
	QFileInfo qFi("/usr/bin/lame");						// lame
		if (qFi.exists() == true) {
			iProgs = 1;
		}

		qFi.setFile("/usr/bin/wavegain");				// wavegain
			if (qFi.exists() == true) {
				iProgs += 10;
			}

		qFi.setFile("/usr/include/taglib/fileref.h");	// taglib, examplary checking for taglib/fileref.h
			if (qFi.exists() == true) {
				iProgs += 100;
			}

	return iProgs;
}


//  ***********************************************************************
//  **  create sub dir
//  ***********************************************************************
int rwDirCreate(const QString sD)			// create (sub)directory, full path
{
	QDir dir(sD);
	if (dir.exists() == false) {
		return dir.mkdir(sD);
	} else {
		return 2;
	}
}


//  ***********************************************************************
//  **  check whether dir is writable
//  ***********************************************************************
bool rwDirChkWritable(const QString sD)		// check whether dir is writable, full path
{
	QFileInfo fi(sD);
	return fi.isWritable();
}


//  ***********************************************************************
//  **  ensure path has a slash at the end
//  ***********************************************************************
QString rwDirPathEnsureSlash(const QString& sD)	// ensure path has a slash at the end
{
	sD2 = sD;
	if (sD2.right(1) != "/") {
		sD2 += "/";
	}
	return sD2;
}

//  ***********************************************************************
//  **  set name of sub dir, 1=wav/ or 2=mp3/
//  ***********************************************************************
QString rwDirSubSetName(const QString& sD, int iD)	// set name of sub dir, 1=wav/ or 2=mp3/
{
	sD2 = sD;
	if (iD == 1) {
		sD2 += "wavs/";
	} else if (iD == 2) {
		sD2 += "mp3s/";
	}
	return sD2;
}

//  ***********************************************************************
//  **  delete dir
//  ***********************************************************************
bool rwDirDel(const QString sD)				// delete (sub)directory, full path
{
	QDir dir(sD);
		return dir.rmdir(sD);					// needs to be empty to succeed
}


//  ***********************************************************************
//  **  get list of mp3s to normalize
//  ***********************************************************************
QStringList rwFilesGet(const QString sD, int iRwD)		// get list of mp3s to process, iRwD=1=mp3s, iRwD=2=wavs
{
	QDir dir(sD);
		dir.setFilter(QDir::Files | QDir::NoDotAndDotDot);
		QStringList filters;
			if (iRwD == 1) {
				filters << "*.mp3" << "*.MP3";				
			} else if (iRwD == 2) {
				filters << "*.wav" << "*.WAV";
			}
		dir.setNameFilters(filters);
//cout << "rwGetMp3s - 1st entry: " << dir.entryList().at(0).toStdString() << endl;                                               // *****  debug  *****
	return dir.entryList();											// incl. full path?
}

//  ***********************************************************************
//  **  delete files
//  ***********************************************************************
bool rwFilesDel(const QStringList slD)			// delete files, full path
{
	b = true;
	QFile fi;
	for (int i = 0; i < slD.size(); ++i) {
		fi.setFileName(slD.at(i));
		if (fi.remove() == false) {
			b = false;
		}
	}
	return b;
}
