/***************************************************************************
 *   Copyright (C) 2009-2016 Helge Kortendieck  <alan@kasmithee.de>		   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef _TAGLIB_H_
#define _TAGLIB_H_

#include <QFileInfo>
#include <QObject>
#include <QString>
#include <QStringList>

#include "structs.h"

// taglib stuff
//#include <audioproperties.h>
#include <fileref.h>
#include <id3v2tag.h>
//#include <id3v2header.h>
#include <mpegfile.h>
#include <tag.h>
#include <textidentificationframe.h>
#include <tstring.h>
using namespace TagLib;

#include <iostream>
using namespace std;

class tags : public QObject
{
Q_OBJECT
public:
	tags(QObject *parent = 0);
		~tags();

private:
	bool bNoTag;		// true if tag is empty

	int iD;
  
	QString sD;

	QString sAlbum;		// album name from tag
	QString sArtist;	// artist name from tag
	QString sComment;	// comment from tag
	QString sComposer;	// composer from tag
	QString sGenre;		// genre from tag
	QString sTitle;		// song title from tag
	QString sTrack;		// track # from tag
	QString sYear;		// year from tag

	QString sSongSrc;	// full path n name of original file
	QString sSongOut;	// full path n name of output file

//	QStringList slTlD;
//	QStringList slTlD2;

	QStringList slErr;			// list with errors and 'OK/Err' at first entry if some OK or all failed

	FilePairs fpTlD;
	QList<FilePairs> liTlFilePairs;	// list struct with file name pairs src n output for taglib to process

private slots:
	void tagsReAdd(const QList<FilePairs>& liTlFilePairs);	// re-add tags to normalized files, list with original files, list with normalized files - both full path n names
	void tagsClear();										// clear tags, if no tag in file
	void tagsGet(const QString& sSongFull);					// get song tag entries via taglib
	void tagsWrite(const QString& sSongFull);				// save tags to mp3

//    void audioInfo(const QString sSongFull);	// get audio properties via taglib

	signals:
//		void sigTagsSaved();
//		void sigTagsWritten();
		void sigTagsFileProc(const QString&);				// update Gui with currently processed file
		void sigTagsReAddEnded(const QStringList&);
};

#endif
