/***************************************************************************
 *   Copyright (C) 2009-2016 Helge Kortendieck  <alan@kasmithee.de>		   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef _WAVEGAIN_H_
#define _WAVEGAIN_H_

#include <QByteArray>
#include <QFileInfo>
#include <QObject>
#include <QProcess>
#include <QString>
#include <QStringList>

#include <iostream>
using namespace std;

class wavegain : public QObject
{
	Q_OBJECT

public:
	wavegain(QObject *parent = 0);
		~wavegain();

private:
	bool bOK;
//	bool bProc;				// process is running

	QByteArray aOutput;		// qprocess output, stdout or stderr

	QProcess *proc;					// qprocess to normalize wavs

	QString sD;
	QString sWDir;			// full path and name of directory with wavs to normalize

	QString sErr;			// all process output on standard error
	QString sStdOut;		// all process output on standard out

	QStringList slArgs;		// list with arguments for qprocess

private slots:
	void procPrep(const QString& sD);

	void procRun();			// start qprocess to check for one of the 4 programs, lame, mp3gain, flac, ogg
	void procStdOut();		// read qprocess stdout
	void procStdErr();		// read qprocess stderr
	void procEnd(int iD, QProcess::ExitStatus iD2);	// qprocess ended
	void procKill();		// kill qprocess, asked to stop

	signals:
		void sigNormFileProc(const QString&);	// update Gui with currently processed file
		void sigNormEnded(bool bOK);			// converted flac or ogg to wav successfully ?
};

#endif // _WAVEGAIN_H_
